#include	<Dialogs.r>
#include	"pcolor.h"
#define	RESFILE
#include	"dialog.h"

#define	smallFSize	SmallFontSize9
#define	sizeAndJust	(kDialogFontUseSizeMask | kDialogFontUseJustMask)
#define	sizeJustFG	(kDialogFontUseSizeMask|kDialogFontUseJustMask|kDialogFontUseForeColorMask)
#define	smallDataItem dataItem{kDialogFontUseSizeMask,0,smallFSize,0,0,0,0,0,0,0,0,0,"\p"}
#define	smallCenterItem dataItem{sizeAndJust,0,smallFSize,0,0,1,0,0,0,0,0,0,"\p"}
#define	smallRightItem dataItem{sizeAndJust,0,smallFSize,0,0,-1,0,0,0,0,0,0,"\p"}
#define	centerItem dataItem{kDialogFontUseJustMask,0,0,0,0,1,0,0,0,0,0,0,"\p"}

// Player dialog
resource 'dlgx' (128, purgeable)
{ versionZero {
	kDialogFlagsUseThemeBackground|
	kDialogFlagsUseControlHierarchy|
	kDialogFlagsUseThemeControls
}};
resource 'dftb' (128, purgeable) 
{ versionZero {{
	dataItem{	// Tabs
		kDialogFontUseSizeMask,
		0,		// Font ID
		smallFSize,		// Font Size
		0,		// Font Style
		0,		// Text Mode
		0,		// Justification
		0,0,0,	// ForeColor RGB
		0,0,0,	// BackColor RGB
		"\p"	// Font Name
	},
	skipItem{},		// radio group
	smallDataItem,	// Radio button (repeat one)
	smallDataItem,	// Radio button (play all)
	skipItem{},		// user pane 1
	smallDataItem,	// EditText (Tempo)
	skipItem{},
	smallDataItem,	// Push button "Apply"
	smallDataItem,	// Push button "Revert"
	skipItem{},		// Text (Tempo)
	skipItem{},
	// Tempo tics labels
	smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem,
	skipItem{},		// user pane 2
	skipItem{},		// user pane for ETS
	skipItem{},		// key slider
	skipItem{},		// key pict
	smallDataItem,	// scale popup-menu
	smallDataItem,	// scale title text
	skipItem{},		// # & b pict
	smallDataItem,	// Equal tempered scale check box
}}};
// Drum & percussion timbre dialog
resource 'dlgx' (129, purgeable)
{ versionZero {
	kDialogFlagsHandleMovableModal|
	kDialogFlagsUseThemeBackground|
	kDialogFlagsUseControlHierarchy|
	kDialogFlagsUseThemeControls
}};
// gene editor dialog
resource 'dlgx' (131, purgeable)
{ versionZero {
	kDialogFlagsUseThemeBackground|
	kDialogFlagsUseControlHierarchy|
	kDialogFlagsUseThemeControls
}};
resource 'dftb' (131, purgeable) 
{ versionZero {{
	smallDataItem, // group box with popup menu for parts
	skipItem{}, skipItem{}, skipItem{},	// buttons
	smallDataItem, smallDataItem, smallDataItem,	// Group box with title text
	// melody buttons
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	// rhythm buttons 
	skipItem{}, skipItem{}, skipItem{}, skipItem{}, skipItem{}, skipItem{},
	skipItem{}, skipItem{}, skipItem{}, skipItem{}, skipItem{}, skipItem{},
	skipItem{}, skipItem{}, skipItem{}, skipItem{},
	// velocity digits
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
}}};
// gedit save-option dialog
resource 'dlgx' (132, purgeable)
{ versionZero {
	kDialogFlagsUseThemeBackground|
	kDialogFlagsUseControlHierarchy|
	kDialogFlagsUseThemeControls
}};
// gene editor dialog
resource 'dlgx' (133, purgeable)
{ versionZero {
	kDialogFlagsUseThemeBackground|
	kDialogFlagsUseControlHierarchy|
	kDialogFlagsUseThemeControls
}};
resource 'dftb' (133, purgeable) 
{ versionZero {{
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallCenterItem, smallCenterItem, smallCenterItem, smallCenterItem,
	smallRightItem, smallRightItem, smallRightItem,
}}};
